/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and individual contributors as indicated
 * by the @authors tag.  All rights reserved. 
 * See the copyright.txt in the distribution for a full listing 
 * of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU General Public License, v. 2.0.
 * This program is distributed in the hope that it will be useful, but WITHOUT A 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License,
 * v. 2.0 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
package com.jboss.transaction.txinterop.webservices.atinterop.processors;

import com.arjuna.webservices.SoapFault;
import com.arjuna.webservices.base.processors.Callback;

import javax.xml.ws.addressing.AddressingProperties;

/**
 * The callback for the initiator client.
 * @author kevin
 */
public abstract class ATInitiatorCallback extends Callback
{
    /**
     * A response.
     * @param addressingProperties The current addressing context.
     */
    public abstract void response(final AddressingProperties addressingProperties) ;

    /**
     * A SOAP fault response.
     * @param soapFault The SOAP fault response.
     * @param addressingProperties The current addressing context.
     */
    public abstract void soapFault(final SoapFault soapFault, final AddressingProperties addressingProperties) ;
}
